POJ-2286-The Rotation Game(IDA*入门)

The Rotation Game
Time Limit: 15000MS Memory Limit: 150000K
Total Submissions: 6299 Accepted: 2121
Description

The rotation game uses a # shaped board, which can hold 24 pieces of square blocks (see Fig.1). The blocks are marked with symbols 1, 2 and 3, with exactly 8 pieces of each kind.
这里写图片描述

Initially, the blocks are placed on the board randomly. Your task is to move the blocks so that the eight blocks placed in the center square have the same symbol marked. There is only one type of valid move, which is to rotate one of the four lines, each consisting of seven blocks. That is, six blocks in the line are moved towards the head by one block and the head block is moved to the end of the line. The eight possible moves are marked with capital letters A to H. Figure 1 illustrates two consecutive moves, move A and move C from some initial configuration.
Input

The input consists of no more than 30 test cases. Each test case has only one line that contains 24 numbers, which are the symbols of the blocks in the initial configuration. The rows of blocks are listed from top to bottom. For each row the blocks are listed from left to right. The numbers are separated by spaces. For example, the first test case in the sample input corresponds to the initial configuration in Fig.1. There are no blank lines between cases. There is a line containing a single `0’ after the last test case that ends the input.
Output

For each test case, you must output two lines. The first line contains all the moves needed to reach the final configuration. Each move is a letter, ranging from A' toH’, and there should not be any spaces between the letters in the line. If no moves are needed, output `No moves needed’ instead. In the second line, you must output the symbol of the blocks in the center square after these moves. If there are several possible solutions, you must output the one that uses the least number of moves. If there is still more than one possible solution, you must output the solution that is smallest in dictionary order for the letters of the moves. There is no need to output blank lines between cases.
Sample Input

1 1 1 1 3 2 3 2 3 1 3 2 2 3 1 2 2 2 3 1 2 1 3 3
1 1 1 1 1 1 1 1 2 2 2 2 2 2 2 2 3 3 3 3 3 3 3 3
0
Sample Output

AC
2
DDHH
2

思路如下

这里写图片描述

A*+迭代深搜=IDA*

代码

#include<stdio.h>
#include<iostream>
#include<algorithm>
#include<string.h>
using namespace std;
int num[25];
string str;
void A()
{
    int flag=num[1];
    num[1]=num[3];
    num[3]=num[7];
    num[7]=num[12];
    num[12]=num[16];
    num[16]=num[21];
    num[21]=num[23];
    num[23]=flag;
}
void B()
{
    int flag=num[2];
    num[2]=num[4];
    num[4]=num[9];
    num[9]=num[13];
    num[13]=num[18];
    num[18]=num[22];
    num[22]=num[24];
    num[24]=flag;
}
void C()
{
    int flag=num[11];
    for(int i=11; i>=6; i--)
        num[i]=num[i-1];
    num[5]=flag;
}
void D()
{
    int flag=num[20];
    for(int i=20; i>=15; i--)
        num[i]=num[i-1];
    num[14]=flag;
}
void E()
{
    int flag=num[24];
    num[24]=num[22];
    num[22]=num[18];
    num[18]=num[13];
    num[13]=num[9];
    num[9]=num[4];
    num[4]=num[2];
    num[2]=flag;
}
void F()
{
    int flag=num[23];
    num[23]=num[21];
    num[21]=num[16];
    num[16]=num[12];
    num[12]=num[7];
    num[7]=num[3];
    num[3]=num[1];
    num[1]=flag;
}
void G()
{
    int flag=num[14];
    for(int i=14; i<=19; i++)
        num[i]=num[i+1];
    num[20]=flag;
}
void H()
{
    int flag=num[5];
    for(int i=5; i<=10; i++)
        num[i]=num[i+1];
    num[11]=flag;
}
int get_H()
{
    int AC[4]= {0};
    AC[num[7]]++;
    AC[num[8]]++;
    AC[num[9]]++;
    AC[num[12]]++;
    AC[num[13]]++;
    AC[num[16]]++;
    AC[num[17]]++;
    AC[num[18]]++;
    return 8-max(AC[1],max(AC[2],AC[3]));
}
bool DFS(int steap,int max_steap)
{
    if(get_H()==0)
    {
        if((int)str.size()==0)
            cout<<"No moves needed"<<endl<<num[7]<<endl;
        else
            cout<<str<<endl<<num[7]<<endl;
        return true;
    }
    if(steap+get_H()>max_steap)
        return false;
    A();
    str+="A";
    if(DFS(steap+1,max_steap)==true)
        return true;
    str.erase(str.end()-1,str.end());
    F();

    B();
    str+="B";
    if(DFS(steap+1,max_steap)==true)
        return true;
    str.erase(str.end()-1,str.end());
    E();

    C();
    str+="C";
    if(DFS(steap+1,max_steap)==true)
        return true;
    str.erase(str.end()-1,str.end());
    H();

    D();
    str+="D";
    if(DFS(steap+1,max_steap)==true)
        return true;
    str.erase(str.end()-1,str.end());
    G();

    E();
    str+="E";
    if(DFS(steap+1,max_steap)==true)
        return true;
    str.erase(str.end()-1,str.end());
    B();

    F();
    str+="F";
    if(DFS(steap+1,max_steap)==true)
        return true;
    str.erase(str.end()-1,str.end());
    A();

    G();
    str+="G";
    if(DFS(steap+1,max_steap)==true)
        return true;
    str.erase(str.end()-1,str.end());
    D();

    H();
    str+="H";
    if(DFS(steap+1,max_steap)==true)
        return true;
    str.erase(str.end()-1,str.end());
    C();
    return false;
}
int main()
{
    while(scanf("%d",&num[1])&&num[1])
    {
        for(int i=2; i<=24; i++)
            scanf("%d",&num[i]);
        int result=0;
        str.clear();
        while(DFS(0,result)==false)
            result++,str.clear();
    }
    return 0;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
这是一道比较经典的计数问题。题目描述如下: 给定一个 $n \times n$ 的网格图,其中一些格子被标记为障碍。一个连通块是指一些被标记为障碍的格子的集合,满足这些格子在网格图中连通。一个格子是连通的当且仅当它与另一个被标记为障碍的格子在网格图中有公共边。 现在,你需要计算在这个网格图中,有多少个不同的连通块,满足这个连通块的大小(即包含的格子数)恰好为 $k$。 这是一道比较经典的计数问题,一般可以通过计算生成函数的方法来解决。具体来说,我们可以定义一个生成函数 $F(x)$,其中 $[x^k]F(x)$ 表示大小为 $k$ 的连通块的个数。那么,我们可以考虑如何计算这个生成函数。 对于一个大小为 $k$ 的连通块,我们可以考虑它的形状。具体来说,我们可以考虑以该连通块的最左边、最上边的格子为起点,从上到下、从左到右遍历该连通块,把每个格子在该连通块中的相对位置记录下来。由于该连通块的大小为 $k$,因此这些相对位置一定是 $(x,y) \in [0,n-1]^2$ 中的 $k$ 个不同点。 现在,我们需要考虑如何计算这些点对应的连通块是否合法。具体来说,我们可以考虑从左到右、从上到下依次处理这些点,对于每个点 $(x,y)$,我们需要考虑它是否能够与左边的点和上边的点连通。具体来说,如果 $(x-1,y)$ 和 $(x,y)$ 都在该连通块中且它们在网格图中有公共边,那么它们就是连通的;同样,如果 $(x,y-1)$ 和 $(x,y)$ 都在该连通块中且它们在网格图中有公共边,那么它们也是连通的。如果 $(x,y)$ 与左边和上边的点都不连通,那么说明这个点不属于该连通块。 考虑到每个点最多只有两个方向需要检查,因此时间复杂度为 $O(n^2 k)$。不过,我们可以使用类似于矩阵乘法的思想,将这个过程优化到 $O(k^3)$ 的时间复杂度。 具体来说,我们可以设 $f_{i,j,k}$ 表示状态 $(i,j)$ 所代表的点在连通块中,且连通块的大小为 $k$ 的方案数。显然,对于一个合法的 $(i,j,k)$,我们可以考虑 $(i-1,j,k-1)$ 和 $(i,j-1,k-1)$ 这两个状态,然后把点 $(i,j)$ 加入到它们所代表的连通块中。因此,我们可以设计一个 $O(k^3)$ 的 DP 状态转移,计算 $f_{i,j,k}$。 具体来说,我们可以考虑枚举连通块所包含的最右边和最下边的格子的坐标 $(x,y)$,然后计算 $f_{x,y,k}$。对于一个合法的 $(x,y,k)$,我们可以考虑将 $(x,y)$ 所代表的点加入到 $(x-1,y,k-1)$ 和 $(x,y-1,k-1)$ 所代表的连通块中。不过,这里需要注意一个细节:如果 $(x-1,y)$ 和 $(x,y)$ 在网格图中没有相邻边,那么它们不能算作连通的。因此,我们需要特判这个情况。 最终,$f_{n,n,k}$ 就是大小为 $k$ 的连通块的个数,时间复杂度为 $O(n^2 k + k^3)$。 参考代码:

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值